//Simulation code for Press
//Generated by OpenModelica.

#include "modelica.h"

#include "assert.h"

#include "string.h"

#include "simulation_runtime.h"

#include "Press_functions.cpp"
extern "C" {
char *model_dir="";
}

#define NHELP 2
#define NG 10//number of zero crossing
#define NX 3
#define NY 6
#define NP 0 // number of parameters
#define NO 0 // number of outputvar on topmodel
#define NI 0 // number of inputvar on topmodel
#define NR 3 // number of residuals for initialialization function
#define NEXT 0 // number of external objects
#define MAXORD 5
#define NYSTR 0 // number of alg. string variables
#define NPSTR 0 // number of alg. string variables



static DATA* localData = 0;
#define time localData->timeValue
char *model_name="Press";
char* state_names[3]={"$dummy", "h", "v"};
char* derivative_names[3]={"der($dummy)", "der(h)", "der(v)"};
char* algvars_names[6]={"controller", "topsensor", "bottomsensor", "ponrsensor", "motoron", "userpushbutton"};
char* input_names[1] = {""};
char* output_names[1] = {""};
char* param_names[1] = {""};
char* string_alg_names[1] = {""};
char* string_param_names[1] = {""};

char* state_comments[3]={"", "", ""};
char* derivative_comments[3]={"", "", ""};
char* algvars_comments[6]={"", "", "", "", "", ""};
char* input_comments[1] = {""};
char* output_comments[1] = {""};
char* param_comments[1] = {""};
char* string_param_comments[1] = {""};
char* string_alg_comments[1] = {""};

#define $userpushbutton localData->algebraics[5]
#define $motoron localData->algebraics[4]
#define $ponrsensor localData->algebraics[3]
#define $bottomsensor localData->algebraics[2]
#define $topsensor localData->algebraics[1]
#define $controller localData->algebraics[0]
#define $v localData->states[2]
#define $derivative$v localData->statesDerivatives[2]
#define $h localData->states[1]
#define $derivative$h localData->statesDerivatives[1]
#define $$dummy localData->states[0]
#define $derivative$$dummy localData->statesDerivatives[0]

char* getName( double* ptr)
{
  if( &$userpushbutton == ptr ) return algvars_names[5];
  if( &$motoron == ptr ) return algvars_names[4];
  if( &$ponrsensor == ptr ) return algvars_names[3];
  if( &$bottomsensor == ptr ) return algvars_names[2];
  if( &$topsensor == ptr ) return algvars_names[1];
  if( &$controller == ptr ) return algvars_names[0];
  if( &$derivative$v == ptr ) return derivative_names[2];
  if( &$v == ptr ) return state_names[2];
  if( &$derivative$h == ptr ) return derivative_names[1];
  if( &$h == ptr ) return state_names[1];
  if( &$derivative$$dummy == ptr ) return derivative_names[0];
  if( &$$dummy == ptr ) return state_names[0];

  return "";
}
static char init_fixed[NX+NX+NY+NP]={1/*$dummy*/, 1/*h*/, 1/*v*/, 1/*default*/, 
1/*default*/, 1/*default*/, 0/*controller*/, 
0/*topsensor*/, 0/*bottomsensor*/, 0/*ponrsensor*/, 
0/*motoron*/, 0/*userpushbutton*/};
char var_attr[NX+NY+NP]={/*$dummy:*/1+0, /*h:*/1+0, /*v:*/1+0, /*controller:*/4+16, 
/*topsensor:*/8+16, /*bottomsensor:*/8+16, /*ponrsensor:*/8+16, 
/*motoron:*/8+16, /*userpushbutton:*/8+16};
#define DIVISION(a,b,c) ((b != 0) ? a / b : a / division_error(b,c))


int encounteredDivisionByZero = 0;
double division_error(double b,const char* division_str)
{
  if(!encounteredDivisionByZero){
    fprintf(stderr,"ERROR: Division by zero in partial equation: %s.\n",division_str);
    encounteredDivisionByZero = 1;
   }   return b;
}


void setLocalData(DATA* data)
{

   localData = data;
}

DATA* initializeDataStruc(DATA_FLAGS flags)
{


  DATA* returnData = (DATA*)malloc(sizeof(DATA));

  if(!returnData) //error check

    return 0;

  memset(returnData,0,sizeof(DATA))
;
  returnData->nStates = NX;

  returnData->nAlgebraic = NY;

  returnData->nParameters = NP;

  returnData->nInputVars = NI;

  returnData->nOutputVars = NO;

  returnData->nZeroCrossing = NG;

  returnData->nInitialResiduals = NR;

  returnData->nHelpVars = NHELP;
  returnData->stringVariables.nParameters = NPSTR;

  returnData->stringVariables.nAlgebraic = NYSTR;
  if(flags & STATES && returnData->nStates){

    returnData->states = (double*) malloc(sizeof(double)*returnData->nStates);

    returnData->oldStates = (double*) malloc(sizeof(double)*returnData->nStates);

    returnData->oldStates2 = (double*) malloc(sizeof(double)*returnData->nStates);

    assert(returnData->states&&returnData->oldStates&&returnData->oldStates2);
    memset(returnData->states,0,sizeof(double)*returnData->nStates);

    memset(returnData->oldStates,0,sizeof(double)*returnData->nStates);

    memset(returnData->oldStates2,0,sizeof(double)*returnData->nStates);
    
  }else{

    returnData->states = 0;

    returnData->oldStates = 0;

    returnData->oldStates2 = 0;

  }
  if(flags & STATESDERIVATIVES && returnData->nStates){

    returnData->statesDerivatives = (double*) malloc(sizeof(double)*returnData->nStates);

    returnData->oldStatesDerivatives = (double*) malloc(sizeof(double)*returnData->nStates);

    returnData->oldStatesDerivatives2 = (double*) malloc(sizeof(double)*returnData->nStates);

    assert(returnData->statesDerivatives&&returnData->oldStatesDerivatives&&returnData->oldStatesDerivatives2);
    memset(returnData->statesDerivatives,0,sizeof(double)*returnData->nStates);

    memset(returnData->oldStatesDerivatives,0,sizeof(double)*returnData->nStates);

    memset(returnData->oldStatesDerivatives2,0,sizeof(double)*returnData->nStates);
    
  }else{

    returnData->statesDerivatives = 0;

    returnData->oldStatesDerivatives = 0;

    returnData->oldStatesDerivatives2 = 0;

  }
  if(flags & HELPVARS && returnData->nHelpVars){

    returnData->helpVars = (double*) malloc(sizeof(double)*returnData->nHelpVars);

    assert(returnData->helpVars);
    memset(returnData->helpVars,0,sizeof(double)*returnData->nHelpVars);
  }else{

    returnData->helpVars = 0;

  }
  if(flags & ALGEBRAICS && returnData->nAlgebraic){

    returnData->algebraics = (double*) malloc(sizeof(double)*returnData->nAlgebraic);

    returnData->oldAlgebraics = (double*) malloc(sizeof(double)*returnData->nAlgebraic);

    returnData->oldAlgebraics2 = (double*) malloc(sizeof(double)*returnData->nAlgebraic);
        
     assert(returnData->algebraics&&returnData->oldAlgebraics&&returnData->oldAlgebraics2);
    memset(returnData->algebraics,0,sizeof(double)*returnData->nAlgebraic);

    memset(returnData->oldAlgebraics,0,sizeof(double)*returnData->nAlgebraic);

    memset(returnData->oldAlgebraics2,0,sizeof(double)*returnData->nAlgebraic);

  }else{

    returnData->algebraics = 0;

    returnData->oldAlgebraics = 0;

    returnData->oldAlgebraics2 = 0;
    
    returnData->stringVariables.algebraics = 0;
  }
if (flags & ALGEBRAICS && returnData->stringVariables.nAlgebraic) {
    returnData->stringVariables.algebraics = (char**)malloc(sizeof(char*)*returnData->stringVariables.nAlgebraic);

    assert(returnData->stringVariables.algebraics);

    memset(returnData->stringVariables.algebraics,0,sizeof(char*)*returnData->stringVariables.nAlgebraic);

    } else {
    returnData->stringVariables.algebraics=0;

    }  if(flags & PARAMETERS && returnData->nParameters){

    returnData->parameters = (double*) malloc(sizeof(double)*returnData->nParameters);

    assert(returnData->parameters);
    memset(returnData->parameters,0,sizeof(double)*returnData->nParameters);
  }else{

    returnData->parameters = 0;

  }
if (flags & PARAMETERS && returnData->stringVariables.nParameters) {
  	  returnData->stringVariables.parameters = (char**)malloc(sizeof(char*)*returnData->stringVariables.nParameters);

      assert(returnData->stringVariables.parameters);

      memset(returnData->stringVariables.parameters,0,sizeof(char*)*returnData->stringVariables.nParameters);

    } else {
      returnData->stringVariables.parameters=0;

    } if(flags & OUTPUTVARS && returnData->nOutputVars){

    returnData->outputVars = (double*) malloc(sizeof(double)*returnData->nOutputVars);

    assert(returnData->outputVars);
    memset(returnData->outputVars,0,sizeof(double)*returnData->nOutputVars);
  }else{

    returnData->outputVars = 0;

  }
  if(flags & INPUTVARS && returnData->nInputVars){

    returnData->inputVars = (double*) malloc(sizeof(double)*returnData->nInputVars);

    assert(returnData->inputVars);
    memset(returnData->inputVars,0,sizeof(double)*returnData->nInputVars);
  }else{

    returnData->inputVars = 0;

  }
  if(flags & INITIALRESIDUALS && returnData->nInitialResiduals){

    returnData->initialResiduals = (double*) malloc(sizeof(double)*returnData->nInitialResiduals);

    assert(returnData->initialResiduals);
    memset(returnData->initialResiduals,0,sizeof(double)*returnData->nInitialResiduals);
  }else{

    returnData->initialResiduals = 0;

  }
  if(flags & INITFIXED){

    returnData->initFixed = init_fixed;

  }else{

    returnData->initFixed = 0;

  }

  /*   names   */

  if(flags & MODELNAME){

    returnData->modelName = model_name;

  }else{

    returnData->modelName = 0;

  }

  if(flags & STATESNAMES){

    returnData->statesNames = state_names;

  }else{

    returnData->statesNames = 0;

  }
if(flags & STATESDERIVATIVESNAMES){

    returnData->stateDerivativesNames = derivative_names;

  }else{

    returnData->stateDerivativesNames = 0;

  }
if(flags & ALGEBRAICSNAMES){

    returnData->algebraicsNames = algvars_names;

  }else{

    returnData->algebraicsNames = 0;

  }
if(flags & PARAMETERSNAMES){

    returnData->parametersNames = param_names;

  }else{

    returnData->parametersNames = 0;

  }
if(flags & INPUTNAMES){

    returnData->inputNames = input_names;

  }else{

    returnData->inputNames = 0;

  }
if(flags & OUTPUTNAMES){

    returnData->outputNames = output_names;

  }else{

    returnData->outputNames = 0;

  }

  /*   comments  */

  if(flags & STATESCOMMENTS){

    returnData->statesComments = state_comments;

  }else{

    returnData->statesComments = 0;

  }
if(flags & STATESDERIVATIVESCOMMENTS){

    returnData->stateDerivativesComments = derivative_comments;

  }else{

    returnData->stateDerivativesComments = 0;

  }
if(flags & ALGEBRAICSCOMMENTS){

    returnData->algebraicsComments = algvars_comments;

  }else{

    returnData->algebraicsComments = 0;

  }
if(flags & PARAMETERSCOMMENTS){

    returnData->parametersComments = param_comments;

  }else{

    returnData->parametersComments = 0;

  }
if(flags & INPUTCOMMENTS){

    returnData->inputComments = input_comments;

  }else{

    returnData->inputComments = 0;

  }
if(flags & OUTPUTCOMMENTS){

    returnData->outputComments = output_comments;

  }else{

    returnData->outputComments = 0;

  }
if (flags & EXTERNALVARS) {

  returnData->extObjs = (void**)malloc(sizeof(void*)*NEXT);

  if (!returnData->extObjs) { 

     printf("error allocating external objects\n");

     exit(-2);

  }
memset(returnData->extObjs,0,sizeof(void*)*NEXT);
setLocalData(returnData); /* must be set since used by constructors*/


  }

  return returnData;

}
void deInitializeDataStruc(DATA* data, DATA_FLAGS flags)

{
  if(!data)

    return;
  if(flags & STATES && data->states){
    free(data->states);
    data->states = 0;
  }
  if(flags & STATESDERIVATIVES && data->statesDerivatives){
    free(data->statesDerivatives);
    data->statesDerivatives = 0;
  }
  if(flags & ALGEBRAICS && data->algebraics){
    free(data->algebraics);
    data->algebraics = 0;
  }
  if(flags & PARAMETERS && data->parameters){
    free(data->parameters);
    data->parameters = 0;
  }
  if(flags & OUTPUTVARS && data->inputVars){
    free(data->inputVars);
    data->inputVars = 0;
  }
  if(flags & INPUTVARS && data->outputVars){

    free(data->outputVars);

    data->outputVars = 0;

  }

  if(flags & INITIALRESIDUALS && data->initialResiduals){

    free(data->initialResiduals);

    data->initialResiduals = 0;

  }

  if (flags & EXTERNALVARS && data->extObjs) {



    free(data->extObjs);

    data->extObjs = 0;

  }

}

int functionDAE_output()
{
  state mem_state;


  mem_state = get_memory_state();

  restore_memory_state(mem_state);
  return 0;

}
int functionDAE_output2()
{
  state mem_state;


  mem_state = get_memory_state();

  restore_memory_state(mem_state);
  return 0;

}

/*
*/
int input_function()
{
  return 0;

}

/*
*/
int output_function()
{
  return 0;

}
int functionDAE_res(double *t, double *x, double *xd, double *delta, long int *ires, double *rpar, long int* ipar)
{
  int i;
  double temp_xd[NX];
  double* statesBackup;
  double* statesDerivativesBackup;
  double timeBackup;


  statesBackup = localData->states;
  statesDerivativesBackup = localData->statesDerivatives;
  timeBackup = localData->timeValue;
  localData->states = x;
  for (i=0; i<localData->nStates; i++) temp_xd[i]=localData->statesDerivatives[i];
  
  localData->statesDerivatives = temp_xd;
  localData->timeValue = *t;
  
  functionODE();
  /* get the difference between the temp_xd(=localData->statesDerivatives) and xd(=statesDerivativesBackup)*/
   for (i=0; i < localData->nStates; i++) delta[i]=localData->statesDerivatives[i]-statesDerivativesBackup[i];
  
  localData->states = statesBackup;
  localData->statesDerivatives = statesDerivativesBackup;
  localData->timeValue = timeBackup;
  if (modelErrorCode) {
    if (ires) *ires = -1;
    modelErrorCode =0;
  }
  return 0;


}
int function_zeroCrossing(long *neqm, double *t, double *x, long *ng, double *gout, double *rpar, long* ipar)
{
  double timeBackup;
  state mem_state;


  mem_state = get_memory_state();
  timeBackup = localData->timeValue;
  localData->timeValue = *t;
  functionODE();
  functionDAE_output();
  ZEROCROSSING(0,Greater($h,0.0));

  ZEROCROSSING(1,GreaterEq($v,0.0));

  ZEROCROSSING(2,Less($h,7.0));

  ZEROCROSSING(3,Less(time,8.0));

  ZEROCROSSING(4,Less(5.0,time));

  ZEROCROSSING(5,Less($h,1.44));

  ZEROCROSSING(6,LessEq($h,0.0));

  ZEROCROSSING(7,GreaterEq($h,7.0));

  ZEROCROSSING(8,Less($h,0.0));

  ZEROCROSSING(9,Greater($h,7.0));


  restore_memory_state(mem_state);
  localData->timeValue = timeBackup;
  return 0;

}
int handleZeroCrossing(long index)
{
  state mem_state;


  mem_state = get_memory_state();
  switch(index) {
    case 0:

    save($v);
    break;
    case 1:

    save($v);
    break;
    case 2:

    save($v);
    break;
    case 3:

    save($userpushbutton);
    break;
    case 4:

    save($userpushbutton);
    break;
    case 5:

    save($ponrsensor);
    break;
    case 6:

    save($bottomsensor);
    break;
    case 7:

    save($topsensor);
    break;
    case 8:

    break;
    case 9:

    break;

    default: break;
  }
  restore_memory_state(mem_state);
  return 0;

}
int function_updateDependents()
{
  state mem_state;
  sin_rettype tmp0;
  modelica_boolean tmp1;
  modelica_boolean tmp2;
  modelica_boolean tmp3;
  modelica_boolean tmp4;
  modelica_boolean tmp5;
  modelica_boolean tmp6;
  modelica_boolean tmp7;
  modelica_boolean tmp8;
  modelica_boolean tmp9;
  modelica_boolean tmp10;
  modelica_boolean tmp11;
  modelica_boolean tmp12;
  modelica_boolean tmp13;
  modelica_boolean tmp14;
  modelica_boolean tmp15;
  modelica_boolean tmp16;
  modelica_boolean tmp17;
  modelica_boolean tmp18;
  modelica_boolean tmp19;
  modelica_boolean tmp20;
  modelica_boolean tmp21;
  modelica_boolean tmp22;

  inUpdate=initial()?0:1;

  mem_state = get_memory_state();
  $derivative$h = $v;
  tmp0 = sin((time * 628.318530717));
  $derivative$$dummy = tmp0;
  RELATIONLESS(tmp1,5.0,time);
  RELATIONLESS(tmp2,time,8.0);
  $userpushbutton = (tmp1 && tmp2);
  RELATIONLESS(tmp3,$h,1.44);
  $ponrsensor = tmp3;
  RELATIONLESSEQ(tmp4,$h,0.0);
  $bottomsensor = tmp4;
  RELATIONGREATEREQ(tmp5,$h,7.0);
  $topsensor = tmp5;
  tmp6 = ((modelica_integer)$controller == 1);
  if (tmp6) {
    tmp7 = $userpushbutton;
    if (tmp7) {
    }
    else {
    }
  }
  else {
    tmp8 = ((modelica_integer)$controller == 2);
    if (tmp8) {
      tmp9 = $ponrsensor;
      if (tmp9) {
      }
      else {
        tmp10 = (!$userpushbutton);
        if (tmp10) {
        }
        else {
        }
      }
    }
    else {
      tmp11 = ((modelica_integer)$controller == 3);
      if (tmp11) {
        tmp12 = $bottomsensor;
        if (tmp12) {
        }
        else {
        }
      }
      else {
        tmp13 = $topsensor;
        if (tmp13) {
        }
        else {
        }
      }
    }
  }
  $controller = ((tmp6)?((tmp7)?2:1):((tmp8)?((tmp9)?3:((tmp10)?0:2)):((tmp11)?((tmp12)?0:3):((tmp13)?1:0))));
  $motoron = (((modelica_integer)$controller == 0) || ((modelica_integer)$controller == 1));
  tmp14 = $motoron;
  if (tmp14) {
    RELATIONLESS(tmp15,$h,7.0);
    tmp16 = tmp15;
    if (tmp16) {
      RELATIONGREATEREQ(tmp17,$v,0.0);
      tmp18 = tmp17;
      if (tmp18) {
      }
      else {
      }
    }
    else {
    }
  }
  else {
    RELATIONGREATER(tmp19,$h,0.0);
    tmp20 = tmp19;
    if (tmp20) {
    }
    else {
    }
  }
  $derivative$v = ((tmp14)?((tmp16)?((tmp18)?0.88:13.5):0.0):((tmp20)?-3.5:0.0));
  RELATIONLESS(tmp21,$h,0.0);
  localData->helpVars[0] = tmp21;
  RELATIONGREATER(tmp22,$h,7.0);
  localData->helpVars[1] = tmp22;

  restore_memory_state(mem_state);
  inUpdate=0;
  return 0;

}
int function_when(int i)
{
  state mem_state;


  mem_state = get_memory_state();
  switch(i) {
     case 0: //when {$h < 0.0,$h > 7.0}

    $v = 0;

    break;
    default: break;
  }

  restore_memory_state(mem_state);
  return 0;

}
int functionODE()
{
  state mem_state;
  sin_rettype tmp0;
  modelica_boolean tmp1;
  modelica_boolean tmp2;
  modelica_boolean tmp3;
  modelica_boolean tmp4;


  mem_state = get_memory_state();
  $derivative$h = $v;
  tmp0 = sin((time * 628.318530717));
  $derivative$$dummy = tmp0;
  tmp1 = $motoron;
  if (tmp1) {
    tmp2 = ($h < 7.0);
    if (tmp2) {
      tmp3 = ($v >= 0.0);
      if (tmp3) {
      }
      else {
      }
    }
    else {
    }
  }
  else {
    tmp4 = ($h > 0.0);
    if (tmp4) {
    }
    else {
    }
  }
  $derivative$v = ((tmp1)?((tmp2)?((tmp3)?0.88:13.5):0.0):((tmp4)?-3.5:0.0));

  restore_memory_state(mem_state);
  return 0;

}
int initial_function()
{



  return 0;

}
int initial_residual()
{
  sin_rettype tmp0;
  modelica_boolean tmp1;
  modelica_boolean tmp2;
  modelica_boolean tmp3;
  modelica_boolean tmp4;
  modelica_boolean tmp5;
  modelica_boolean tmp6;
  modelica_boolean tmp7;
  int i=0;
  state mem_state;


  mem_state = get_memory_state();
  tmp0 = sin((time * 628.318530717));
  localData->initialResiduals[i++] = ($derivative$$dummy - tmp0);
  localData->initialResiduals[i++] = ($derivative$h - $v);
  tmp1 = $motoron;
  if (tmp1) {
    RELATIONLESS(tmp2,$h,7.0);
    tmp3 = tmp2;
    if (tmp3) {
      RELATIONGREATEREQ(tmp4,$v,0.0);
      tmp5 = tmp4;
      if (tmp5) {
      }
      else {
      }
    }
    else {
    }
  }
  else {
    RELATIONGREATER(tmp6,$h,0.0);
    tmp7 = tmp6;
    if (tmp7) {
    }
    else {
    }
  }
  localData->initialResiduals[i++] = ($derivative$v - ((tmp1)?((tmp3)?((tmp5)?0.88:13.5):0.0):((tmp7)?-3.5:0.0)));

  restore_memory_state(mem_state);
  return 0;

}
int bound_parameters()
{
  state mem_state;


  mem_state = get_memory_state();

  restore_memory_state(mem_state);
  return 0;

}
int checkForDiscreteVarChanges()
{
  int needToIterate=0;
  if (edge(localData->helpVars[0])) AddEvent(0 + localData->nZeroCrossing);
  if (edge(localData->helpVars[1])) AddEvent(0 + localData->nZeroCrossing);
  if (change($userpushbutton)) { needToIterate=1; }
  if (change($motoron)) { needToIterate=1; }
  if (change($ponrsensor)) { needToIterate=1; }
  if (change($bottomsensor)) { needToIterate=1; }
  if (change($topsensor)) { needToIterate=1; }
  if (change($controller)) { needToIterate=1; }
  for (long i = 0; i < localData->nHelpVars; i++) {
    if (change(localData->helpVars[i])) { needToIterate=1; }
  }
  return needToIterate;
}
