//Simulation code for TrapezoidTest
//Generated by OpenModelica.

#include "modelica.h"

#include "assert.h"

#include "string.h"

#include "simulation_runtime.h"

#include "TrapezoidTest_functions.cpp"
extern "C" {

}

#define NHELP 6
#define NG 10//number of zero crossing
#define NX 1
#define NY 8
#define NP 22 // number of parameters
#define NO 0 // number of outputvar on topmodel
#define NI 0 // number of inputvar on topmodel
#define NR 3 // number of residuals for initialialization function
#define NEXT 0 // number of external objects
#define MAXORD 5
#define NYSTR 0 // number of alg. string variables
#define NPSTR 0 // number of alg. string variables

static DATA* localData = 0;
#define time localData->timeValue
extern "C"
{
char *model_name="TrapezoidTest";
char *model_dir="";
}
char* state_names[1]={"$dummy"};
char* derivative_names[1]={"der($dummy)"};
char* algvars_names[8]={"trap1.y", "trap1.T0", "trap1.counter", "trap1.counter2", "trap2.y", "trap2.T0", "trap2.counter", "trap2.counter2"};
char* input_names[1] = {""};
char* output_names[1] = {""};
char* param_names[22]={"trap1.amplitude", "trap1.rising", "trap1.width", "trap1.falling", "trap1.period", "trap1.nperiod", "trap1.offset", "trap1.startTime", "trap1.T_rising", "trap1.T_width", "trap1.T_falling", "trap2.amplitude", "trap2.rising", "trap2.width", "trap2.falling", "trap2.period", "trap2.nperiod", "trap2.offset", "trap2.startTime", "trap2.T_rising", "trap2.T_width", "trap2.T_falling"};
char* string_alg_names[1] = {""};
char* string_param_names[1] = {""};

char* state_comments[1]={""};
char* derivative_comments[1]={""};
char* algvars_comments[8]={ "Connector of Real output signal",  "Start time of current period",  "Period counter", "",  "Connector of Real output signal",  "Start time of current period",  "Period counter", ""};
char* input_comments[1] = {""};
char* output_comments[1] = {""};
char* param_comments[22]={ "Amplitude of trapezoid",  "Rising duration of trapezoid",  "Width duration of trapezoid",  "Falling duration of trapezoid",  "Time for one period",  "Number of periods (< 0 means infinite number of periods)",  "Offset of output signal",  "Output = offset for time < startTime",  "End time of rising phase within one period",  "End time of width phase within one period",  "End time of falling phase within one period",  "Amplitude of trapezoid",  "Rising duration of trapezoid",  "Width duration of trapezoid",  "Falling duration of trapezoid",  "Time for one period",  "Number of periods (< 0 means infinite number of periods)",  "Offset of output signal",  "Output = offset for time < startTime",  "End time of rising phase within one period",  "End time of width phase within one period",  "End time of falling phase within one period"};
char* string_param_comments[22]={ "Amplitude of trapezoid",  "Rising duration of trapezoid",  "Width duration of trapezoid",  "Falling duration of trapezoid",  "Time for one period",  "Number of periods (< 0 means infinite number of periods)",  "Offset of output signal",  "Output = offset for time < startTime",  "End time of rising phase within one period",  "End time of width phase within one period",  "End time of falling phase within one period",  "Amplitude of trapezoid",  "Rising duration of trapezoid",  "Width duration of trapezoid",  "Falling duration of trapezoid",  "Time for one period",  "Number of periods (< 0 means infinite number of periods)",  "Offset of output signal",  "Output = offset for time < startTime",  "End time of rising phase within one period",  "End time of width phase within one period",  "End time of falling phase within one period"};
char* string_alg_comments[22]={ "Amplitude of trapezoid",  "Rising duration of trapezoid",  "Width duration of trapezoid",  "Falling duration of trapezoid",  "Time for one period",  "Number of periods (< 0 means infinite number of periods)",  "Offset of output signal",  "Output = offset for time < startTime",  "End time of rising phase within one period",  "End time of width phase within one period",  "End time of falling phase within one period",  "Amplitude of trapezoid",  "Rising duration of trapezoid",  "Width duration of trapezoid",  "Falling duration of trapezoid",  "Time for one period",  "Number of periods (< 0 means infinite number of periods)",  "Offset of output signal",  "Output = offset for time < startTime",  "End time of rising phase within one period",  "End time of width phase within one period",  "End time of falling phase within one period"};

#define $trap2$pointT_falling localData->parameters[21]
#define $trap2$pointT_width localData->parameters[20]
#define $trap2$pointT_rising localData->parameters[19]
#define $trap2$pointstartTime localData->parameters[18]
#define $trap2$pointoffset localData->parameters[17]
#define $trap2$pointnperiod localData->parameters[16]
#define $trap2$pointperiod localData->parameters[15]
#define $trap2$pointfalling localData->parameters[14]
#define $trap2$pointwidth localData->parameters[13]
#define $trap2$pointrising localData->parameters[12]
#define $trap2$pointamplitude localData->parameters[11]
#define $trap1$pointT_falling localData->parameters[10]
#define $trap1$pointT_width localData->parameters[9]
#define $trap1$pointT_rising localData->parameters[8]
#define $trap1$pointstartTime localData->parameters[7]
#define $trap1$pointoffset localData->parameters[6]
#define $trap1$pointnperiod localData->parameters[5]
#define $trap1$pointperiod localData->parameters[4]
#define $trap1$pointfalling localData->parameters[3]
#define $trap1$pointwidth localData->parameters[2]
#define $trap1$pointrising localData->parameters[1]
#define $trap1$pointamplitude localData->parameters[0]
#define $trap2$pointcounter2 localData->algebraics[7]
#define $trap2$pointcounter localData->algebraics[6]
#define $trap2$pointT0 localData->algebraics[5]
#define $trap2$pointy localData->algebraics[4]
#define $trap1$pointcounter2 localData->algebraics[3]
#define $trap1$pointcounter localData->algebraics[2]
#define $trap1$pointT0 localData->algebraics[1]
#define $trap1$pointy localData->algebraics[0]
#define $$dummy localData->states[0]
#define $derivative$$dummy localData->statesDerivatives[0]

char* getName( double* ptr)
{
  if( &$trap2$pointT_falling == ptr ) return param_names[21];
  if( &$trap2$pointT_width == ptr ) return param_names[20];
  if( &$trap2$pointT_rising == ptr ) return param_names[19];
  if( &$trap2$pointstartTime == ptr ) return param_names[18];
  if( &$trap2$pointoffset == ptr ) return param_names[17];
  if( &$trap2$pointnperiod == ptr ) return param_names[16];
  if( &$trap2$pointperiod == ptr ) return param_names[15];
  if( &$trap2$pointfalling == ptr ) return param_names[14];
  if( &$trap2$pointwidth == ptr ) return param_names[13];
  if( &$trap2$pointrising == ptr ) return param_names[12];
  if( &$trap2$pointamplitude == ptr ) return param_names[11];
  if( &$trap1$pointT_falling == ptr ) return param_names[10];
  if( &$trap1$pointT_width == ptr ) return param_names[9];
  if( &$trap1$pointT_rising == ptr ) return param_names[8];
  if( &$trap1$pointstartTime == ptr ) return param_names[7];
  if( &$trap1$pointoffset == ptr ) return param_names[6];
  if( &$trap1$pointnperiod == ptr ) return param_names[5];
  if( &$trap1$pointperiod == ptr ) return param_names[4];
  if( &$trap1$pointfalling == ptr ) return param_names[3];
  if( &$trap1$pointwidth == ptr ) return param_names[2];
  if( &$trap1$pointrising == ptr ) return param_names[1];
  if( &$trap1$pointamplitude == ptr ) return param_names[0];
  if( &$trap2$pointcounter2 == ptr ) return algvars_names[7];
  if( &$trap2$pointcounter == ptr ) return algvars_names[6];
  if( &$trap2$pointT0 == ptr ) return algvars_names[5];
  if( &$trap2$pointy == ptr ) return algvars_names[4];
  if( &$trap1$pointcounter2 == ptr ) return algvars_names[3];
  if( &$trap1$pointcounter == ptr ) return algvars_names[2];
  if( &$trap1$pointT0 == ptr ) return algvars_names[1];
  if( &$trap1$pointy == ptr ) return algvars_names[0];
  if( &$derivative$$dummy == ptr ) return derivative_names[0];
  if( &$$dummy == ptr ) return state_names[0];

  return "";
}
static char init_fixed[NX+NX+NY+NP]={1/*$dummy*/, 1/*default*/, 0/*trap1.y*/, 0/*trap1.T0*/, 
0/*trap1.counter*/, 0/*trap1.counter2*/, 0/*trap2.y*/, 
0/*trap2.T0*/, 0/*trap2.counter*/, 0/*trap2.counter2*/, 
1/*trap1.amplitude*/, 1/*trap1.rising*/, 1/*trap1.width*/, 
1/*trap1.falling*/, 1/*trap1.period*/, 1/*trap1.nperiod*/, 
1/*trap1.offset*/, 1/*trap1.startTime*/, 1/*trap1.T_rising*/, 
1/*trap1.T_width*/, 1/*trap1.T_falling*/, 1/*trap2.amplitude*/, 
1/*trap2.rising*/, 1/*trap2.width*/, 1/*trap2.falling*/, 
1/*trap2.period*/, 1/*trap2.nperiod*/, 1/*trap2.offset*/, 
1/*trap2.startTime*/, 1/*trap2.T_rising*/, 1/*trap2.T_width*/, 
1/*trap2.T_falling*/};
char var_attr[NX+NY+NP]={/*$dummy:*/1+0, /*trap1.y:*/1+0, /*trap1.T0:*/1+16, /*trap1.counter:*/4+16, 
/*trap1.counter2:*/4+16, /*trap2.y:*/1+0, /*trap2.T0:*/1+16, 
/*trap2.counter:*/4+16, /*trap2.counter2:*/4+16, /*trap1.amplitude:*/1, 
/*trap1.rising:*/1, /*trap1.width:*/1, /*trap1.falling:*/1, 
/*trap1.period:*/1, /*trap1.nperiod:*/4, /*trap1.offset:*/1, 
/*trap1.startTime:*/1, /*trap1.T_rising:*/1, /*trap1.T_width:*/1, 
/*trap1.T_falling:*/1, /*trap2.amplitude:*/1+0, /*trap2.rising:*/1+0, 
/*trap2.width:*/1+0, /*trap2.falling:*/1+0, /*trap2.period:*/1+0, 
/*trap2.nperiod:*/4+16, /*trap2.offset:*/1+0, /*trap2.startTime:*/1+0, 
/*trap2.T_rising:*/1+0, /*trap2.T_width:*/1+0, /*trap2.T_falling:*/1+0};
#define DIVISION(a,b,c) ((b != 0) ? a / b : a / division_error(b,c))


int encounteredDivisionByZero = 0;
double division_error(double b,const char* division_str)
{
  if(!encounteredDivisionByZero){
    fprintf(stderr,"ERROR: Division by zero in partial equation: %s.\n",division_str);
    encounteredDivisionByZero = 1;
   }   return b;
}


void setLocalData(DATA* data)
{

   localData = data;
}

DATA* initializeDataStruc(DATA_FLAGS flags)
{


  DATA* returnData = (DATA*)malloc(sizeof(DATA));

  if(!returnData) //error check

    return 0;

  memset(returnData,0,sizeof(DATA))
;
  returnData->nStates = NX;

  returnData->nAlgebraic = NY;

  returnData->nParameters = NP;

  returnData->nInputVars = NI;

  returnData->nOutputVars = NO;

  returnData->nZeroCrossing = NG;

  returnData->nInitialResiduals = NR;

  returnData->nHelpVars = NHELP;
  returnData->stringVariables.nParameters = NPSTR;

  returnData->stringVariables.nAlgebraic = NYSTR;
  if(flags & STATES && returnData->nStates){

    returnData->states = (double*) malloc(sizeof(double)*returnData->nStates);

    returnData->oldStates = (double*) malloc(sizeof(double)*returnData->nStates);

    returnData->oldStates2 = (double*) malloc(sizeof(double)*returnData->nStates);

    assert(returnData->states&&returnData->oldStates&&returnData->oldStates2);
    memset(returnData->states,0,sizeof(double)*returnData->nStates);

    memset(returnData->oldStates,0,sizeof(double)*returnData->nStates);

    memset(returnData->oldStates2,0,sizeof(double)*returnData->nStates);
    
  }else{

    returnData->states = 0;

    returnData->oldStates = 0;

    returnData->oldStates2 = 0;

  }
  if(flags & STATESDERIVATIVES && returnData->nStates){

    returnData->statesDerivatives = (double*) malloc(sizeof(double)*returnData->nStates);

    returnData->oldStatesDerivatives = (double*) malloc(sizeof(double)*returnData->nStates);

    returnData->oldStatesDerivatives2 = (double*) malloc(sizeof(double)*returnData->nStates);

    assert(returnData->statesDerivatives&&returnData->oldStatesDerivatives&&returnData->oldStatesDerivatives2);
    memset(returnData->statesDerivatives,0,sizeof(double)*returnData->nStates);

    memset(returnData->oldStatesDerivatives,0,sizeof(double)*returnData->nStates);

    memset(returnData->oldStatesDerivatives2,0,sizeof(double)*returnData->nStates);
    
  }else{

    returnData->statesDerivatives = 0;

    returnData->oldStatesDerivatives = 0;

    returnData->oldStatesDerivatives2 = 0;

  }
  if(flags & HELPVARS && returnData->nHelpVars){

    returnData->helpVars = (double*) malloc(sizeof(double)*returnData->nHelpVars);

    assert(returnData->helpVars);
    memset(returnData->helpVars,0,sizeof(double)*returnData->nHelpVars);
  }else{

    returnData->helpVars = 0;

  }
  if(flags & ALGEBRAICS && returnData->nAlgebraic){

    returnData->algebraics = (double*) malloc(sizeof(double)*returnData->nAlgebraic);

    returnData->oldAlgebraics = (double*) malloc(sizeof(double)*returnData->nAlgebraic);

    returnData->oldAlgebraics2 = (double*) malloc(sizeof(double)*returnData->nAlgebraic);
        
     assert(returnData->algebraics&&returnData->oldAlgebraics&&returnData->oldAlgebraics2);
    memset(returnData->algebraics,0,sizeof(double)*returnData->nAlgebraic);

    memset(returnData->oldAlgebraics,0,sizeof(double)*returnData->nAlgebraic);

    memset(returnData->oldAlgebraics2,0,sizeof(double)*returnData->nAlgebraic);

  }else{

    returnData->algebraics = 0;

    returnData->oldAlgebraics = 0;

    returnData->oldAlgebraics2 = 0;
    
    returnData->stringVariables.algebraics = 0;
  }
if (flags & ALGEBRAICS && returnData->stringVariables.nAlgebraic) {
    returnData->stringVariables.algebraics = (char**)malloc(sizeof(char*)*returnData->stringVariables.nAlgebraic);

    assert(returnData->stringVariables.algebraics);

    memset(returnData->stringVariables.algebraics,0,sizeof(char*)*returnData->stringVariables.nAlgebraic);

    } else {
    returnData->stringVariables.algebraics=0;

    }  if(flags & PARAMETERS && returnData->nParameters){

    returnData->parameters = (double*) malloc(sizeof(double)*returnData->nParameters);

    assert(returnData->parameters);
    memset(returnData->parameters,0,sizeof(double)*returnData->nParameters);
  }else{

    returnData->parameters = 0;

  }
if (flags & PARAMETERS && returnData->stringVariables.nParameters) {
  	  returnData->stringVariables.parameters = (char**)malloc(sizeof(char*)*returnData->stringVariables.nParameters);

      assert(returnData->stringVariables.parameters);

      memset(returnData->stringVariables.parameters,0,sizeof(char*)*returnData->stringVariables.nParameters);

    } else {
      returnData->stringVariables.parameters=0;

    } if(flags & OUTPUTVARS && returnData->nOutputVars){

    returnData->outputVars = (double*) malloc(sizeof(double)*returnData->nOutputVars);

    assert(returnData->outputVars);
    memset(returnData->outputVars,0,sizeof(double)*returnData->nOutputVars);
  }else{

    returnData->outputVars = 0;

  }
  if(flags & INPUTVARS && returnData->nInputVars){

    returnData->inputVars = (double*) malloc(sizeof(double)*returnData->nInputVars);

    assert(returnData->inputVars);
    memset(returnData->inputVars,0,sizeof(double)*returnData->nInputVars);
  }else{

    returnData->inputVars = 0;

  }
  if(flags & INITIALRESIDUALS && returnData->nInitialResiduals){

    returnData->initialResiduals = (double*) malloc(sizeof(double)*returnData->nInitialResiduals);

    assert(returnData->initialResiduals);
    memset(returnData->initialResiduals,0,sizeof(double)*returnData->nInitialResiduals);
  }else{

    returnData->initialResiduals = 0;

  }
  if(flags & INITFIXED){

    returnData->initFixed = init_fixed;

  }else{

    returnData->initFixed = 0;

  }

  /*   names   */

  if(flags & MODELNAME){

    returnData->modelName = model_name;

  }else{

    returnData->modelName = 0;

  }

  if(flags & STATESNAMES){

    returnData->statesNames = state_names;

  }else{

    returnData->statesNames = 0;

  }
if(flags & STATESDERIVATIVESNAMES){

    returnData->stateDerivativesNames = derivative_names;

  }else{

    returnData->stateDerivativesNames = 0;

  }
if(flags & ALGEBRAICSNAMES){

    returnData->algebraicsNames = algvars_names;

  }else{

    returnData->algebraicsNames = 0;

  }
if(flags & PARAMETERSNAMES){

    returnData->parametersNames = param_names;

  }else{

    returnData->parametersNames = 0;

  }
if(flags & INPUTNAMES){

    returnData->inputNames = input_names;

  }else{

    returnData->inputNames = 0;

  }
if(flags & OUTPUTNAMES){

    returnData->outputNames = output_names;

  }else{

    returnData->outputNames = 0;

  }

  /*   comments  */

  if(flags & STATESCOMMENTS){

    returnData->statesComments = state_comments;

  }else{

    returnData->statesComments = 0;

  }
if(flags & STATESDERIVATIVESCOMMENTS){

    returnData->stateDerivativesComments = derivative_comments;

  }else{

    returnData->stateDerivativesComments = 0;

  }
if(flags & ALGEBRAICSCOMMENTS){

    returnData->algebraicsComments = algvars_comments;

  }else{

    returnData->algebraicsComments = 0;

  }
if(flags & PARAMETERSCOMMENTS){

    returnData->parametersComments = param_comments;

  }else{

    returnData->parametersComments = 0;

  }
if(flags & INPUTCOMMENTS){

    returnData->inputComments = input_comments;

  }else{

    returnData->inputComments = 0;

  }
if(flags & OUTPUTCOMMENTS){

    returnData->outputComments = output_comments;

  }else{

    returnData->outputComments = 0;

  }
if (flags & EXTERNALVARS) {

  returnData->extObjs = (void**)malloc(sizeof(void*)*NEXT);

  if (!returnData->extObjs) { 

     printf("error allocating external objects\n");

     exit(-2);

  }
memset(returnData->extObjs,0,sizeof(void*)*NEXT);
setLocalData(returnData); /* must be set since used by constructors*/


  }

  return returnData;

}
void deInitializeDataStruc(DATA* data, DATA_FLAGS flags)

{
  if(!data)

    return;
  if(flags & STATES && data->states){
    free(data->states);
    data->states = 0;
  }
  if(flags & STATESDERIVATIVES && data->statesDerivatives){
    free(data->statesDerivatives);
    data->statesDerivatives = 0;
  }
  if(flags & ALGEBRAICS && data->algebraics){
    free(data->algebraics);
    data->algebraics = 0;
  }
  if(flags & PARAMETERS && data->parameters){
    free(data->parameters);
    data->parameters = 0;
  }
  if(flags & OUTPUTVARS && data->inputVars){
    free(data->inputVars);
    data->inputVars = 0;
  }
  if(flags & INPUTVARS && data->outputVars){

    free(data->outputVars);

    data->outputVars = 0;

  }

  if(flags & INITIALRESIDUALS && data->initialResiduals){

    free(data->initialResiduals);

    data->initialResiduals = 0;

  }

  if (flags & EXTERNALVARS && data->extObjs) {



    free(data->extObjs);

    data->extObjs = 0;

  }

}

int functionDAE_output()
{
  state mem_state;
  modelica_boolean tmp0;
  modelica_boolean tmp1;
  modelica_boolean tmp2;
  modelica_boolean tmp3;
  modelica_boolean tmp4;
  modelica_boolean tmp5;
  modelica_boolean tmp6;
  modelica_boolean tmp7;
  modelica_boolean tmp8;
  modelica_boolean tmp9;
  modelica_boolean tmp10;
  modelica_boolean tmp11;
  modelica_boolean tmp12;
  modelica_boolean tmp13;


  mem_state = get_memory_state();
  RELATIONLESS(tmp0,time,$trap2$pointstartTime);
  RELATIONGREATEREQ(tmp1,time,($trap2$pointT0 + $trap2$pointT_falling));
  tmp2 = ((tmp0 || ((modelica_integer)$trap2$pointcounter2 == 0)) || tmp1);
  if (tmp2) {
  }
  else {
    RELATIONLESS(tmp3,time,($trap2$pointT0 + $trap2$pointT_rising));
    tmp4 = tmp3;
    if (tmp4) {
    }
    else {
      RELATIONLESS(tmp5,time,($trap2$pointT0 + $trap2$pointT_width));
      tmp6 = tmp5;
      if (tmp6) {
      }
      else {
      }
    }
  }
  $trap2$pointy = ($trap2$pointoffset + ((tmp2)?0.0:((tmp4)?(((time - $trap2$pointT0) * $trap2$pointamplitude) / $trap2$pointT_rising):((tmp6)?$trap2$pointamplitude:(((($trap2$pointT0 + $trap2$pointT_falling) - time) * $trap2$pointamplitude) / ($trap2$pointT_falling - $trap2$pointT_width))))));

  RELATIONLESS(tmp7,time,$trap1$pointstartTime);
  RELATIONGREATEREQ(tmp8,time,($trap1$pointT0 + $trap1$pointT_falling));
  tmp9 = ((tmp7 || ((modelica_integer)$trap1$pointcounter2 == 0)) || tmp8);
  if (tmp9) {
  }
  else {
    RELATIONLESS(tmp10,time,($trap1$pointT0 + $trap1$pointT_rising));
    tmp11 = tmp10;
    if (tmp11) {
    }
    else {
      RELATIONLESS(tmp12,time,($trap1$pointT0 + $trap1$pointT_width));
      tmp13 = tmp12;
      if (tmp13) {
      }
      else {
      }
    }
  }
  $trap1$pointy = ($trap1$pointoffset + ((tmp9)?0.0:((tmp11)?(((time - $trap1$pointT0) * $trap1$pointamplitude) / $trap1$pointT_rising):((tmp13)?$trap1$pointamplitude:(((($trap1$pointT0 + $trap1$pointT_falling) - time) * $trap1$pointamplitude) / ($trap1$pointT_falling - $trap1$pointT_width))))));


  restore_memory_state(mem_state);
  return 0;

}
int functionDAE_output2()
{
  state mem_state;


  mem_state = get_memory_state();

  restore_memory_state(mem_state);
  return 0;

}

/*
*/
int input_function()
{
  return 0;

}

/*
*/
int output_function()
{
  return 0;

}
int functionDAE_res(double *t, double *x, double *xd, double *delta, long int *ires, double *rpar, long int* ipar)
{
  int i;
  double temp_xd[NX];
  double* statesBackup;
  double* statesDerivativesBackup;
  double timeBackup;


  statesBackup = localData->states;
  statesDerivativesBackup = localData->statesDerivatives;
  timeBackup = localData->timeValue;
  localData->states = x;
  for (i=0; i<localData->nStates; i++) temp_xd[i]=localData->statesDerivatives[i];
  
  localData->statesDerivatives = temp_xd;
  localData->timeValue = *t;
  
  functionODE();
  /* get the difference between the temp_xd(=localData->statesDerivatives) and xd(=statesDerivativesBackup)*/
   for (i=0; i < localData->nStates; i++) delta[i]=localData->statesDerivatives[i]-statesDerivativesBackup[i];
  
  localData->states = statesBackup;
  localData->statesDerivatives = statesDerivativesBackup;
  localData->timeValue = timeBackup;
  if (modelErrorCode) {
    if (ires) *ires = -1;
    modelErrorCode =0;
  }
  return 0;


}
int function_zeroCrossing(long *neqm, double *t, double *x, long *ng, double *gout, double *rpar, long* ipar)
{
  double timeBackup;
  state mem_state;


  mem_state = get_memory_state();
  timeBackup = localData->timeValue;
  localData->timeValue = *t;
  functionODE();
  functionDAE_output();
  ZEROCROSSING(0,Less(time,$trap2$pointT0 + $trap2$pointT_width));

  ZEROCROSSING(1,Less(time,$trap2$pointT0 + $trap2$pointT_rising));

  ZEROCROSSING(2,GreaterEq(time,$trap2$pointT0 + $trap2$pointT_falling));

  ZEROCROSSING(3,Less(time,$trap2$pointstartTime));

  ZEROCROSSING(4,Less(time,$trap1$pointT0 + $trap1$pointT_width));

  ZEROCROSSING(5,Less(time,$trap1$pointT0 + $trap1$pointT_rising));

  ZEROCROSSING(6,GreaterEq(time,$trap1$pointT0 + $trap1$pointT_falling));

  ZEROCROSSING(7,Less(time,$trap1$pointstartTime));

  ZEROCROSSING(8,Sample(*t,$trap1$pointstartTime,$trap1$pointperiod));

  ZEROCROSSING(9,Sample(*t,$trap2$pointstartTime,$trap2$pointperiod));


  restore_memory_state(mem_state);
  localData->timeValue = timeBackup;
  return 0;

}
int handleZeroCrossing(long index)
{
  state mem_state;


  mem_state = get_memory_state();
  switch(index) {
    case 0:

    save($trap2$pointy);
    break;
    case 1:

    save($trap2$pointy);
    break;
    case 2:

    save($trap2$pointy);
    break;
    case 3:

    save($trap2$pointy);
    break;
    case 4:

    save($trap1$pointy);
    break;
    case 5:

    save($trap1$pointy);
    break;
    case 6:

    save($trap1$pointy);
    break;
    case 7:

    save($trap1$pointy);
    break;
    case 8:

    break;
    case 9:

    break;

    default: break;
  }
  restore_memory_state(mem_state);
  return 0;

}
int function_updateDependents()
{
  state mem_state;
  sin_rettype tmp0;
  modelica_boolean tmp1;
  modelica_boolean tmp2;
  modelica_boolean tmp3;
  modelica_boolean tmp4;
  modelica_boolean tmp5;
  modelica_boolean tmp6;
  modelica_boolean tmp7;
  modelica_boolean tmp8;
  modelica_boolean tmp9;
  modelica_boolean tmp10;
  modelica_boolean tmp11;
  modelica_boolean tmp12;
  modelica_boolean tmp13;
  modelica_boolean tmp14;
  modelica_integer tmp15;
  sample_rettype tmp16;
  modelica_integer tmp17;
  sample_rettype tmp18;
  modelica_integer tmp19;
  sample_rettype tmp20;
  modelica_integer tmp21;
  sample_rettype tmp22;
  modelica_integer tmp23;
  sample_rettype tmp24;
  modelica_integer tmp25;
  sample_rettype tmp26;

  inUpdate=initial()?0:1;

  mem_state = get_memory_state();
  tmp0 = sin((time * 628.318530717));
  $derivative$$dummy = tmp0;
  RELATIONLESS(tmp1,time,$trap2$pointstartTime);
  RELATIONGREATEREQ(tmp2,time,($trap2$pointT0 + $trap2$pointT_falling));
  tmp3 = ((tmp1 || ((modelica_integer)$trap2$pointcounter2 == 0)) || tmp2);
  if (tmp3) {
  }
  else {
    RELATIONLESS(tmp4,time,($trap2$pointT0 + $trap2$pointT_rising));
    tmp5 = tmp4;
    if (tmp5) {
    }
    else {
      RELATIONLESS(tmp6,time,($trap2$pointT0 + $trap2$pointT_width));
      tmp7 = tmp6;
      if (tmp7) {
      }
      else {
      }
    }
  }
  $trap2$pointy = ($trap2$pointoffset + ((tmp3)?0.0:((tmp5)?(((time - $trap2$pointT0) * $trap2$pointamplitude) / $trap2$pointT_rising):((tmp7)?$trap2$pointamplitude:(((($trap2$pointT0 + $trap2$pointT_falling) - time) * $trap2$pointamplitude) / ($trap2$pointT_falling - $trap2$pointT_width))))));
  RELATIONLESS(tmp8,time,$trap1$pointstartTime);
  RELATIONGREATEREQ(tmp9,time,($trap1$pointT0 + $trap1$pointT_falling));
  tmp10 = ((tmp8 || ((modelica_integer)$trap1$pointcounter2 == 0)) || tmp9);
  if (tmp10) {
  }
  else {
    RELATIONLESS(tmp11,time,($trap1$pointT0 + $trap1$pointT_rising));
    tmp12 = tmp11;
    if (tmp12) {
    }
    else {
      RELATIONLESS(tmp13,time,($trap1$pointT0 + $trap1$pointT_width));
      tmp14 = tmp13;
      if (tmp14) {
      }
      else {
      }
    }
  }
  $trap1$pointy = ($trap1$pointoffset + ((tmp10)?0.0:((tmp12)?(((time - $trap1$pointT0) * $trap1$pointamplitude) / $trap1$pointT_rising):((tmp14)?$trap1$pointamplitude:(((($trap1$pointT0 + $trap1$pointT_falling) - time) * $trap1$pointamplitude) / ($trap1$pointT_falling - $trap1$pointT_width))))));
  tmp15 = (modelica_integer)pre($trap1$pointcounter2);
  tmp16 = sample($trap1$pointstartTime, $trap1$pointperiod);
  localData->helpVars[5] = ((tmp15 != 0) && tmp16);
  tmp17 = (modelica_integer)pre($trap1$pointcounter2);
  tmp18 = sample($trap1$pointstartTime, $trap1$pointperiod);
  localData->helpVars[4] = ((tmp17 != 0) && tmp18);
  tmp19 = (modelica_integer)pre($trap1$pointcounter2);
  tmp20 = sample($trap1$pointstartTime, $trap1$pointperiod);
  localData->helpVars[3] = ((tmp19 != 0) && tmp20);
  tmp21 = (modelica_integer)pre($trap2$pointcounter2);
  tmp22 = sample($trap2$pointstartTime, $trap2$pointperiod);
  localData->helpVars[2] = ((tmp21 != 0) && tmp22);
  tmp23 = (modelica_integer)pre($trap2$pointcounter2);
  tmp24 = sample($trap2$pointstartTime, $trap2$pointperiod);
  localData->helpVars[1] = ((tmp23 != 0) && tmp24);
  tmp25 = (modelica_integer)pre($trap2$pointcounter2);
  tmp26 = sample($trap2$pointstartTime, $trap2$pointperiod);
  localData->helpVars[0] = ((tmp25 != 0) && tmp26);

  restore_memory_state(mem_state);
  inUpdate=0;
  return 0;

}
int function_when(int i)
{
  modelica_integer tmp0;
  modelica_integer tmp1;
  modelica_integer tmp2;
  modelica_boolean tmp3;
  modelica_integer tmp4;
  modelica_integer tmp5;
  modelica_integer tmp6;
  modelica_boolean tmp7;
  state mem_state;


  mem_state = get_memory_state();
  switch(i) {
     case 0: //when pre($trap2$pointcounter2) <> 0 AND sample($trap2$pointstartTime,$trap2$pointperiod)

    save($trap2$pointT0);
	fprintf(stdout, "T0:%f becoming time:%f\n", $trap2$pointT0, time);
    $trap2$pointT0 = time;	

    
    break;
     case 1: //when pre($trap2$pointcounter2) <> 0 AND sample($trap2$pointstartTime,$trap2$pointperiod)

    save($trap2$pointcounter2);	
    tmp0 = (modelica_integer)pre($trap2$pointcounter);
	fprintf(stdout, "trap2.counter2:%f becoming :%d\n", $trap2$pointcounter2, tmp0);
    $trap2$pointcounter2 = tmp0;

    
    break;
     case 2: //when pre($trap2$pointcounter2) <> 0 AND sample($trap2$pointstartTime,$trap2$pointperiod)

    save($trap2$pointcounter);

    tmp1 = (modelica_integer)pre($trap2$pointcounter);
    tmp2 = (modelica_integer)pre($trap2$pointcounter);
    tmp3 = (tmp2 > 0);
    if (tmp3) {
    }
    else {
    }
	fprintf(stdout, "trap2.counter:%f becoming :%d\n", $trap2$pointcounter, (tmp1 - ((tmp3)?1:0)));
    $trap2$pointcounter = (tmp1 - ((tmp3)?1:0));

    
    break;
     case 3: //when pre($trap1$pointcounter2) <> 0 AND sample($trap1$pointstartTime,$trap1$pointperiod)

    save($trap1$pointT0);

    $trap1$pointT0 = time;

    
    break;
     case 4: //when pre($trap1$pointcounter2) <> 0 AND sample($trap1$pointstartTime,$trap1$pointperiod)

    save($trap1$pointcounter2);

    tmp4 = (modelica_integer)pre($trap1$pointcounter);
    $trap1$pointcounter2 = tmp4;

    
    break;
     case 5: //when pre($trap1$pointcounter2) <> 0 AND sample($trap1$pointstartTime,$trap1$pointperiod)

    save($trap1$pointcounter);

    tmp5 = (modelica_integer)pre($trap1$pointcounter);
    tmp6 = (modelica_integer)pre($trap1$pointcounter);
    tmp7 = (tmp6 > 0);
    if (tmp7) {
    }
    else {
    }
    $trap1$pointcounter = (tmp5 - ((tmp7)?1:0));

    
    break;
    default: break;
  }

  restore_memory_state(mem_state);
  return 0;

}
int functionODE()
{
  state mem_state;
  sin_rettype tmp0;


  mem_state = get_memory_state();
  tmp0 = sin((time * 628.318530717));
  $derivative$$dummy = tmp0;

  restore_memory_state(mem_state);
  return 0;

}
int initial_function()
{


  $trap2$pointT_falling = ($trap2$pointT_width + $trap2$pointfalling);
  $trap2$pointT_width = ($trap2$pointT_rising + $trap2$pointwidth);
  $trap2$pointT_rising = $trap2$pointrising;
  $trap1$pointT_falling = ($trap1$pointT_width + $trap1$pointfalling);
  $trap1$pointT_width = ($trap1$pointT_rising + $trap1$pointwidth);
  $trap1$pointT_rising = $trap1$pointrising;
  $trap1$pointT0 = $trap1$pointstartTime;
  if (sim_verbose) { printf("Setting variable start value:%s(start=%f)\n", "trap1.T0", $trap1$pointstartTime); }
  $trap1$pointcounter = (modelica_integer)$trap1$pointnperiod;
  if (sim_verbose) { printf("Setting variable start value:%s(start=%f)\n", "trap1.counter", (modelica_integer)$trap1$pointnperiod); }
  $trap1$pointcounter2 = (modelica_integer)$trap1$pointnperiod;
  if (sim_verbose) { printf("Setting variable start value:%s(start=%f)\n", "trap1.counter2", (modelica_integer)$trap1$pointnperiod); }
  $trap2$pointT0 = $trap2$pointstartTime;
  if (sim_verbose) { printf("Setting variable start value:%s(start=%f)\n", "trap2.T0", $trap2$pointstartTime); }
  $trap2$pointcounter = (modelica_integer)$trap2$pointnperiod;
  if (sim_verbose) { printf("Setting variable start value:%s(start=%f)\n", "trap2.counter", (modelica_integer)$trap2$pointnperiod); }
  $trap2$pointcounter2 = (modelica_integer)$trap2$pointnperiod;
  if (sim_verbose) { printf("Setting variable start value:%s(start=%f)\n", "trap2.counter2", (modelica_integer)$trap2$pointnperiod); }

  return 0;

}
int initial_residual()
{
  modelica_boolean tmp0;
  modelica_boolean tmp1;
  modelica_boolean tmp2;
  modelica_boolean tmp3;
  modelica_boolean tmp4;
  modelica_boolean tmp5;
  modelica_boolean tmp6;
  modelica_boolean tmp7;
  modelica_boolean tmp8;
  modelica_boolean tmp9;
  modelica_boolean tmp10;
  modelica_boolean tmp11;
  modelica_boolean tmp12;
  modelica_boolean tmp13;
  sin_rettype tmp14;
  int i=0;
  state mem_state;


  mem_state = get_memory_state();
  RELATIONLESS(tmp0,time,$trap1$pointstartTime);
  RELATIONGREATEREQ(tmp1,time,($trap1$pointT0 + $trap1$pointT_falling));
  tmp2 = ((tmp0 || ((modelica_integer)$trap1$pointcounter2 == 0)) || tmp1);
  if (tmp2) {
  }
  else {
    RELATIONLESS(tmp3,time,($trap1$pointT0 + $trap1$pointT_rising));
    tmp4 = tmp3;
    if (tmp4) {
    }
    else {
      RELATIONLESS(tmp5,time,($trap1$pointT0 + $trap1$pointT_width));
      tmp6 = tmp5;
      if (tmp6) {
      }
      else {
      }
    }
  }
  localData->initialResiduals[i++] = ($trap1$pointy - ($trap1$pointoffset + ((tmp2)?0.0:((tmp4)?(((time - $trap1$pointT0) * $trap1$pointamplitude) / $trap1$pointT_rising):((tmp6)?$trap1$pointamplitude:(((($trap1$pointT0 + $trap1$pointT_falling) - time) * $trap1$pointamplitude) / ($trap1$pointT_falling - $trap1$pointT_width)))))));
  RELATIONLESS(tmp7,time,$trap2$pointstartTime);
  RELATIONGREATEREQ(tmp8,time,($trap2$pointT0 + $trap2$pointT_falling));
  tmp9 = ((tmp7 || ((modelica_integer)$trap2$pointcounter2 == 0)) || tmp8);
  if (tmp9) {
  }
  else {
    RELATIONLESS(tmp10,time,($trap2$pointT0 + $trap2$pointT_rising));
    tmp11 = tmp10;
    if (tmp11) {
    }
    else {
      RELATIONLESS(tmp12,time,($trap2$pointT0 + $trap2$pointT_width));
      tmp13 = tmp12;
      if (tmp13) {
      }
      else {
      }
    }
  }
  localData->initialResiduals[i++] = ($trap2$pointy - ($trap2$pointoffset + ((tmp9)?0.0:((tmp11)?(((time - $trap2$pointT0) * $trap2$pointamplitude) / $trap2$pointT_rising):((tmp13)?$trap2$pointamplitude:(((($trap2$pointT0 + $trap2$pointT_falling) - time) * $trap2$pointamplitude) / ($trap2$pointT_falling - $trap2$pointT_width)))))));
  tmp14 = sin((time * 628.318530717));
  localData->initialResiduals[i++] = ($derivative$$dummy - tmp14);

  restore_memory_state(mem_state);
  return 0;

}
int bound_parameters()
{
  state mem_state;


  mem_state = get_memory_state();
  $trap2$pointT_falling = ($trap2$pointT_width + $trap2$pointfalling);
  $trap2$pointT_width = ($trap2$pointT_rising + $trap2$pointwidth);
  $trap2$pointT_rising = $trap2$pointrising;
  $trap1$pointT_falling = ($trap1$pointT_width + $trap1$pointfalling);
  $trap1$pointT_width = ($trap1$pointT_rising + $trap1$pointwidth);
  $trap1$pointT_rising = $trap1$pointrising;

  restore_memory_state(mem_state);
  return 0;

}
int checkForDiscreteVarChanges()
{
  int needToIterate=0;
  if (edge(localData->helpVars[5])) AddEvent(5 + localData->nZeroCrossing);
  if (edge(localData->helpVars[4])) AddEvent(4 + localData->nZeroCrossing);
  if (edge(localData->helpVars[3])) AddEvent(3 + localData->nZeroCrossing);
  if (edge(localData->helpVars[2])) 
	  AddEvent(2 + localData->nZeroCrossing);
  if (edge(localData->helpVars[1])) 
	  AddEvent(1 + localData->nZeroCrossing);
  if (edge(localData->helpVars[0])) 
	  AddEvent(0 + localData->nZeroCrossing);
  if (change($trap2$pointcounter2)) 
  { 
	  needToIterate=1; 
  }
  if (change($trap2$pointcounter)) 
  { 
	  needToIterate=1; 
  }
  if (change($trap2$pointT0)) 
  { 
	  needToIterate=1; 
  }
  if (change($trap1$pointcounter2)) { needToIterate=1; }
  if (change($trap1$pointcounter)) { needToIterate=1; }
  if (change($trap1$pointT0)) { needToIterate=1; }
  for (long i = 0; i < localData->nHelpVars; i++) {
    if (change(localData->helpVars[i])) 
	{ 
		needToIterate=1; 
	}
  }
  return needToIterate;
}
